#include <def21367.h>
#define NUM_COEFFS 8
#define N 128

.section/DATA64 seg_dmda;
.var input[N]="input.data";
.var output[N];
.var delayline[NUM_COEFFS];
.var delayline2[NUM_COEFFS];

.section/DATA64 seg_pmda;
.var coeffs[NUM_COEFFS]= "fixedcoeffs.h";
.var coeffs2[NUM_COEFFS]= "fixedcoeffs.h";
.var expected_output[N]="expected_output.dat";

.section/pm seg_pmco;
.global _main;
_main:

//Enable Circular Buffering and SIMD
bit set mode1 CBUFEN|PEYEN;

b0=delayline;   //Pointer to the first DL
l0=NUM_COEFFS;  //Number of taps
b8=delayline2;  //Pointer to the second DL
l8=NUM_COEFFS;  //Number of taps
i4=input;       //Pointer to first input
l4=0;           //Make sure input won't wrap
i11=input+N/2-NUM_COEFFS/2;       //Pointer to second input
l11=0;          //Make sure second input won't wrap
b5=output;      //Pointer to first output
b10=output;     //Pointer to second output
l5=N;           //Number of samples
i10=output+N/2-NUM_COEFFS/2;       //Pointer to second output, not necessary if there are two separate outputs
l10=N;          //Number of samples
b9=coeffs2;      //Pointer to second set of taps
l9=NUM_COEFFS;  //Number of taps
b1=coeffs;      //Pointer to first set of taps
l1=NUM_COEFFS;  //Number of taps

//Set up Modifiers
m6=1;
m14=1;
m7=-1;
m15=-1;
m5=0;
m13=0;
m12=2;
m4=2;

//Adjust output pointers
modify(i5,-1);
modify(i10,-1);
//Read first input
r0=dm(i4,m6);
s0=pm(i11,m14);

//Zero accumulators
r6=0;
r7=0;
mrf=r6*r7(uuf);
mrb=r6*r7(uuf);

//Store input to DL, Read first tap
dm(i0,m7)=r0, r2=pm(i9,m14);
r2=dm(i1,m6),pm(i8,m15)=r0;

//Outer loop for block, when splitting the input, loop is half the block size, plus half the number of taps
lcntr=N/2+NUM_COEFFS/2, do fir64_end until lce;

fir_start:

    //Multiply least significant halves with taps in MRF
    mrf=r0*r2 (uuf), r0=dm(i0,m7), r2=pm(i9,m14);
    r2=dm(i1,m6),r0=pm(i8,m15);

    lcntr=NUM_COEFFS-1, do m_st until lce;
        mrf=mrf+r0*r2 (uuf), r0=dm(i0,m7), r2=pm(i9,m14);
    m_st: r2=dm(i1,m6),r0=pm(i8,m15);

    //Copy from most significant 32-bits of the low half multiplication
    //Store Outputs from last pass through the loop
    r6=mr1f,dm(i5,m6)=r4;
    mr0b=r6,pm(i10,m14)=s4;
    r7=0;
    mr1b=r7;

    //Cross multiply upper and lower halves in MRB
    //Multiply upper halves in MRF
    mrf=r1*r3(ssf);
    mrb=mrb+r1*r2(suf);

    lcntr=NUM_COEFFS-1, do MAC until lce;
        mrb=mrb+r3*r0(suf),r0=dm(i0,m7), r2=pm(i9,m14);
        r2=dm(i1,m6),r0=pm(i8,m15);
        mrb=mrb+r1*r2(suf);
    MAC:    mrf=mrf+r1*r3(ssf);
    mrb=mrb+r3*r0(suf),r2=dm(i0,m6);

    //Collect MRB and MRF into registers for final addition
    //Read next inputs
    r4=mr0f,r0=dm(i4,m6);
    r5=mr1f,s0=pm(i11,m14);
    r6=mr0b,r2=pm(i8,m14);
    r7=mr1b;

    //Shift result of mixed multiplies by 31 bits (don't need sign bit)
    r6=lshift r6 by -31;
    r6=r6 OR lshift r7 by 1;
    r7=lshift r7 by -31;

    //Final 64-bit addition of MRB and MRF
    //Store input to DL, Read first tap
    r4=r4+r6,dm(i0,m7)=r0, r2=pm(i9,m14);
fir64_end:  r5=r5+r7+CI,r2=dm(i1,m6),pm(i8,m15)=r0;

//Save final outputs
dm(i5,m6)=r4;
pm(i10,m14)=s4;

_main.end: jump(pc,0);
